#include <math.h>
#include <stdio.h>

#include "Unit1.h"
#include "co2func.h"
#include "func.h"

//co2 func
//---------------------------------------------------------------------------
double fc(int dd,double xd,int dt,double xt)
{

	double N[]={0,
    	0.38856823203161,		0.29385475942740e1,		-0.55867188534934e1,
        -0.76753199592477,		0.31729005580416,		0.54803315897767,
		0.12279411220335,		0.2165896154322e1,		0.15841735109724e1,
        -0.23132705405503,		0.58116916431436e-1,	-0.55369137205382,
        0.48946615909422,		-0.24275739843501e-1,	0.62494790501678e-1,
        -0.12175860225246,		-0.37055685270086,		-0.16775879700426e-1,
        -0.11960736637987,		-0.45619362508778e-1,	0.35612789270346e-1,
        -0.74427727132052e-2,	-0.17395704902432e-2,	-0.21810121289527e-1,
        0.24332166559236e-1,	-0.37440133423463e-1,	0.14338715756878,
        -0.13491969083286,		-0.2315122505348e-1,	0.12363125492901e-1,
        0.2105832197294e-2,		-0.33958519026368e-3,	0.55993651771592e-2,
        -0.30335118055646e-3,	-0.2136548868832e3,		0.26641569149272e5,
		-0.24027212204557e5,	-0.28341603423999e3,	0.21247284400179e3,
        -0.66642276540751,		0.72608632349897,		0.55068668612842e-1
		},
	t[]={0,
		0,0.75,1,2,0.75,
        2,0.75,1.5,1.5,2.5,
        0,1.5,2,0,1,
        2,3,6,3,6,
        8,6,0,7,12,
        16,22,24,16,24,
        8,2,28,14,1,
        0,1,3,3
    },
    g[]={0,
    	1.16,1.19,1.19,1.25,1.22
    };						//for gi=gamma(i-34)


	int d[]={0,
		1,1,1,1,2,
        2,3,1,2,4,
        5,5,5,6,6,
        6,1,1,4,4,
        4,7,8,2,3,
        3,5,5,6,7,
        8,10,4,8,2,
        2,2,3,3
	},

	c[]={0,
    	0,0,0,0,0,
        0,0,1,1,1,
		1,1,1,1,1,
        1,2,2,2,2,
		2,2,2,3,3,
        3,4,4,4,4,
        4,4,5,6,25,
        25,25,15,20
	},			//i=35-39,ci=alpha-i

	b[]={0,
    	325,300,300,275,275
    };				//for bi=beta(i-34)

    int i;
	double xa=0,xd1sq=(xd-1)*(xd-1);

    if(dt==0){
	    if(dd==0){
	    	for(i=1;i<8;i++) xa+=N[i]*pow(xd,d[i])*pow(xt,t[i]);
	    	for(i=8;i<35;i++)
    			xa+=N[i]*pow(xd,d[i])*pow(xt,t[i])*exp(-pow(xd,c[i]));
    		for(i=35;i<40;i++){
            	double xtgsq=(xt-g[i-34])*(xt-g[i-34]);

    			xa+=N[i]*pow(xd,d[i])*pow(xt,t[i])
                		*exp(-c[i]*xd1sq-b[i-34]*xtgsq);
            }
            for(i=40;i<43;i++){
	            xa+=N[i]*fcdelb(0,xd,0,xt,i)*xd*fcphi(0,xd,0,xt,i);
			}
    	}
	    if(dd==1){
	    	for(i=1;i<8;i++) xa+=N[i]*d[i]*pow(xd,d[i]-1)*pow(xt,t[i]);
	    	for(i=8;i<35;i++)
    			xa+=N[i]*pow(xd,d[i]-1)*pow(xt,t[i])
                		*(d[i]-c[i]*pow(xd,c[i]))*exp(-pow(xd,c[i]));
    		for(i=35;i<40;i++){
            	double xtgsq=(xt-g[i-34])*(xt-g[i-34]);

    			xa+=N[i]*pow(xd,d[i])*pow(xt,t[i])
                	*(d[i]/xd-2*c[i]*(xd-1))
                    *exp(-c[i]*xd1sq-b[i-34]*xtgsq);
            }
            for(i=40;i<43;i++){
                double delb=fcdelb(0,xd,0,xt,i),phi=fcphi(0,xd,0,xt,i),
                		delbd=fcdelb(1,xd,0,xt,i),phid=fcphi(1,xd,0,xt,i);

	            xa+=N[i]*(delb*(phi+xd*phid)+delbd*xd*phi);
			}
        }
	    if(dd==2){
	    	for(i=1;i<8;i++) xa+=N[i]*d[i]*(d[i]-1)*pow(xd,d[i]-2)*pow(xt,t[i]);
	    	for(i=8;i<35;i++)
    			xa+=N[i]*pow(xd,d[i]-2)*pow(xt,t[i])
                		*((d[i]-c[i]*pow(xd,c[i]))*(d[i]-1-c[i]*pow(xd,c[i]))
                        	-c[i]*c[i]*pow(xd,c[i]))*exp(-pow(xd,c[i]));
    		for(i=35;i<40;i++){
            	double xtgsq=(xt-g[i-34])*(xt-g[i-34]);

    			xa+=N[i]*pow(xt,t[i])
                	*(-2*c[i]*pow(xd,d[i])
                    	+4*c[i]*c[i]*pow(xd,d[i])*xd1sq
                    	-4*d[i]*c[i]*pow(xd,d[i]-1)*(xd-1)
                        +d[i]*(d[i]-1)*pow(xd,d[i]-2))
                	*exp(-c[i]*xd1sq-b[i-34]*xtgsq);
            }
            for(i=40;i<43;i++){
                double delb=fcdelb(0,xd,0,xt,i),phi=fcphi(0,xd,0,xt,i),
						delbd=fcdelb(1,xd,0,xt,i),phid=fcphi(1,xd,0,xt,i),
                        delbdd=fcdelb(2,xd,0,xt,i),phidd=fcphi(2,xd,0,xt,i);

	            xa+=N[i]*(delb*(2*phid+xd*phidd)
                			+2*delbd*(phi+xd*phid)+delbdd*xd*phi);
			}
		}
	}
    if(dt==1){
		if(dd==0){
	    	for(i=1;i<8;i++) xa+=N[i]*t[i]*pow(xd,d[i])*pow(xt,t[i]-1);
	    	for(i=8;i<35;i++)
    			xa+=N[i]*t[i]*pow(xd,d[i])*pow(xt,t[i]-1)*exp(-pow(xd,c[i]));
    		for(i=35;i<40;i++){
            	double xtgsq=(xt-g[i-34])*(xt-g[i-34]);

    			xa+=N[i]*pow(xd,d[i])*pow(xt,t[i])
                	*(t[i]/xt-2*b[i-34]*(xt-g[i-34]))
                    *exp(-c[i]*xd1sq-b[i-34]*xtgsq);
            }
            for(i=40;i<43;i++){
            	double delb=fcdelb(0,xd,0,xt,i),delbt=fcdelb(0,xd,1,xt,i),
                		phi=fcphi(0,xd,0,xt,i),phit=fcphi(0,xd,1,xt,i);

	            xa+=N[i]*xd*(delbt*phi+delb*phit);
            }
		}
		if(dd==1){
	    	for(i=1;i<8;i++) xa+=N[i]*d[i]*t[i]*pow(xd,d[i]-1)*pow(xt,t[i]-1);
	    	for(i=8;i<35;i++)
    			xa+=N[i]*t[i]*(d[i]-c[i]*pow(xd,c[i]))
                	*pow(xd,d[i]-1)*pow(xt,t[i]-1)*exp(-pow(xd,c[i]));
    		for(i=35;i<40;i++){
            	double xtgsq=(xt-g[i-34])*(xt-g[i-34]);

    			xa+=N[i]*pow(xd,d[i])*pow(xt,t[i])
					*(d[i]/xd-2*c[i]*(xd-1))
                	*(t[i]/xt-2*b[i-34]*(xt-g[i-34]))
                	*exp(-c[i]*xd1sq-b[i-34]*xtgsq);
            }
            for(i=40;i<43;i++){
            	double delb=fcdelb(0,xd,0,xt,i),delbt=fcdelb(0,xd,1,xt,i),
                	delbd=fcdelb(1,xd,0,xt,i),delbtd=fcdelb(1,xd,1,xt,i),
                    phi=fcphi(0,xd,0,xt,i),phid=fcphi(1,xd,0,xt,i),
                    phit=fcphi(0,xd,1,xt,i),phitd=fcphi(1,xd,1,xt,i);

                xa+=N[i]*(delb*(phit+xd*phitd)+xd*delbd*phit
                			+delbt*(phi+xd*phid)+delbtd*xd*phi);
			}
		}
    }
    if(dt==2){
		if(dd==0){
	    	for(i=1;i<8;i++) xa+=N[i]*t[i]*(t[i]-1)*pow(xd,d[i])*pow(xt,t[i]-2);
	    	for(i=8;i<35;i++)
    			xa+=N[i]*t[i]*(t[i]-1)
                	*pow(xd,d[i])*pow(xt,t[i]-2)*exp(-pow(xd,c[i]));
    		for(i=35;i<40;i++){
            	double xtgsq=(xt-g[i-34])*(xt-g[i-34]),
                		xx=t[i]/xt-2*b[i-34]*(xt-g[i-34]);

    			xa+=N[i]*pow(xd,d[i])*pow(xt,t[i])
                	*(xx*xx-t[i]/(xt*xt)-2*b[i-34])
                	*exp(-c[i]*xd1sq-b[i-34]*xtgsq);
			}
            for(i=40;i<43;i++){
            	double delb=fcdelb(0,xd,0,xt,i),delbt=fcdelb(0,xd,1,xt,i),
                    delbtt=fcdelb(0,xd,2,xt,i),phi=fcphi(0,xd,0,xt,i),
                    phit=fcphi(0,xd,1,xt,i),phitt=fcphi(0,xd,2,xt,i);

	            xa+=N[i]*xd*(delbtt*phi+2*delbt*phit+delb*phitt);
            }
    	}
    }
    if(dt==-2){	//special form for Second Virial Coef. *ds

	    	for(i=1;i<5;i++) xa+=N[i]*pow(xt,t[i]);

   			xa+=N[8]*pow(xt,t[8])+N[17]*pow(xt,t[17])+N[18]*pow(xt,t[18]);

            for(i=40;i<43;i++){
                double delb0=fcdelb(0,0,0,xt,i),phi0=fcphi(0,0,0,xt,i);

	            xa+=N[i]*delb0*phi0;
			}
    }

    return xa;
}
//---------------------------------------------------------------------------
double fcdel(int dd,double xd,int dt,double xt,int xi) //treat in i=40-42 of fc
{
	//dt assumes 0.

	double xdel;

    int i=xi-40;
    double a[]={3.5,3.5,3.0},B[]={0.3,0.3,1.0},
			binv=1.0/0.3,xd1sq=(xd-1)*(xd-1);
    double th=1-xt+0.7*pow(xd1sq,0.5*binv);

	if(dd==0) return th*th+B[i]*pow(xd1sq,a[i]);

    if(xd1sq==0) return 0;  //for xd=1, next procedure includes 0^(-a)

	if(dd==1)
    	xdel=(1.4*th*binv*pow(xd1sq,0.5*binv-1)
        		+2*B[i]*a[i]*pow(xd1sq,a[i]-1))*(xd-1);
	if(dd==2){
    	double xx=0.7*binv*pow(xd1sq,0.5*binv-1);
    	    xdel=1.4*th*binv*pow(xd1sq,0.5*binv-1)
        		+2*B[i]*a[i]*pow(xd1sq,a[i]-1)
                +xd1sq*(
                	4*B[i]*a[i]*(a[i]-1)*pow(xd1sq,a[i]-2)
                	+2*xx*xx
                	+2.8*th*binv*(0.5*binv-1)*pow(xd1sq,0.5*binv-2));
	}
    return xdel;
}
//---------------------------------------------------------------------------
double fcdelb(int dd,double xd,int dt,double xt,int xi) //treat in i=40-42 of fc
{
	double xdelb;

    int i=xi-40;
    double b[]={0.875,0.925,0.875},binv=1.0/0.3,xd1sq=(xd-1)*(xd-1);

    double del=fcdel(0,xd,0,xt,xi),
			th=1-xt+0.7*pow(xd1sq,0.5*binv);

    if(del==0) return 0;    //for del=0, next procedure includes 0^(-a)

    if(dt==0){
		if(dd==0) return pow(del,b[i]);
		if(dd==1) xdelb=b[i]*pow(del,b[i]-1)*fcdel(1,xd,0,xt,xi);
		if(dd==2){
        	double deld=fcdel(1,xd,0,xt,xi);

        	xdelb=b[i]*(pow(del,b[i]-1)*fcdel(2,xd,0,xt,xi)
            	+(b[i]-1)*pow(del,b[i]-2)*deld*deld);
    	}
    }
    if(dt==1){
		if(dd==0) xdelb=-2*th*b[i]*pow(del,b[i]-1);
		if(dd==1) xdelb=-1.4*b[i]*binv*pow(del,b[i]-1)
        					*(xd-1)*pow(xd1sq,0.5*binv-1)
        				-2*th*b[i]*(b[i]-1)*pow(del,b[i]-2)*fcdel(1,xd,0,xt,xi);
    }
    if(dt==2){
		if(dd==0) xdelb=2*b[i]*pow(del,b[i]-1)
        				+4*th*th*b[i]*(b[i]-1)*pow(del,b[i]-2);
    }

	return xdelb;
}
//---------------------------------------------------------------------------
double fcphi(int dd,double xd,int dt,double xt,int xi)	//treat in i=40-42 of fc
{

    int i=xi-40;

	double xphi,C[]={10.0,10.0,12.5},xd1sq=(xd-1)*(xd-1),xt1sq=(xt-1)*(xt-1);

    if(dt==0){
		if(dd==0) xphi=1;
		if(dd==1) xphi=-2*C[i]*(xd-1);
		if(dd==2) xphi=2*C[i]*(2*C[i]*xd1sq-1);
    }
    if(dt==1){
		if(dd==0) xphi=-550*(xt-1);
		if(dd==1) xphi=2*C[i]*550*(xd-1)*(xt-1);
    }
    if(dt==2){
		if(dd==0) xphi=550*(550*xt1sq-1);
    }

	return xphi*exp(-C[i]*xd1sq-275*xt1sq);
}
//---------------------------------------------------------------------------
double fcid(int dt,double xt)		//log(xd) need to be included
{
	double F[]={0,
			8.37304456,		-3.70454304,	2.5,			1.99427042,
            0.62105248,		0.41195293,		1.04028922,		0.08327678
        },
    G[]={0,
			0,0,0,		3.15163,
            6.1119,		6.77708,	11.32384,	27.08792
    	};

	double xaid;
	if(dt==0){
	    xaid=F[1]+F[2]*xt+F[3]*log(xt);
	    for(int i=4;i<9;i++) xaid+=F[i]*log(1.0-exp(-G[i]*xt));
	}
    if(dt==1){
	    xaid=F[2]+F[3]/xt;
	    for(int i=4;i<9;i++)
        	xaid+=F[i]*G[i]*(1.0/(1.0-exp(-G[i]*xt))-1);
    }
	if(dt==2){
		xaid=-F[3]/(xt*xt);
    	for(int i=4;i<9;i++){
			double expGT=exp(-G[i]*xt);

    		xaid-=F[i]*G[i]*G[i]*expGT/((1.0-expGT)*(1.0-expGT));
		}
    }
	return xaid;
}
//---------------------------------------------------------------------------
double fctherc0(double xd,double xt)
{
    double zt=xt*100/Ts;	//yt=100/T

	double rsq=2.387869e-2/zt+4.350794
					+zt*(-10.33404+zt*(7.981590-1.940558*zt));
    zt/=100;

    rsq=0.4*(rsq*exp(-183.5*zt)+1.0);

    zt*=251.196;	//zt=251.196/T

    double xl0=0.4226159+zt*(0.6280115+zt*(-0.5387661+
    				zt*(0.6735941+zt*zt*zt*(-0.4362677+0.2255388*zt))));

	zt/=251.196;

    xl0=0.475598*sqrt(1.0/zt)*(1.0+rsq)/xl0;

    double zd=xd*ds*Mw*1e-3;
	double xld=zd*(2.447164e-2+zd*(8.705605e-5+zd*(-6.547950e-8+zd*6.594919e-11)));

    return 1e-3*(xl0+xld);
}
//---------------------------------------------------------------------------
double fctherc(double xd,double xt,double xvisc0,double xvisc,double xtherc0,
        double xxgzai,double xcp,double xcv)
{
	double zd=xd*ds*Mw*1e-3,zt=Ts/xt;

	double qgzai=xxgzai/2.3e-10;
    if(qgzai<ALM0) return 0;

    double qgzai1=sqrt(1+qgzai*qgzai);
    double yD=atan2(xxgzai,2.3e-10);    //atan(qgzai)
    double yd=(atan2(qgzai,qgzai1)-yD)/qgzai1;
	double ya=zd*kB*zt/(8*M_PI*xvisc0*xvisc0*xxgzai),
    		yb=xtherc0/(xvisc0*(xcp-xcv)),yc=xcv/(xcp-xcv);

    complex a[]={complex(yc*ya*yd,0),complex(yc*ya*yD,0),
                    complex(yc+yb+ya*yd,0),complex(yD*ya,0),complex(1.0,0)},z[4];

    sol4(a,z);

    if(z[0]==z[1]&&z[1]==z[2]&&z[2]==z[3]) return -1;

    z[0]=-z[0];
    z[1]=-z[1];
    z[2]=-z[2];
    z[3]=-z[3];

	complex **M;
	M=(complex**) malloc(sizeof(complex*)*4);
	M[0]=(complex*) malloc(sizeof(complex)*4);
	M[1]=(complex*) malloc(sizeof(complex)*4);
	M[2]=(complex*) malloc(sizeof(complex)*4);
	M[3]=(complex*) malloc(sizeof(complex)*4);


    M[0][0]=M[0][1]=M[0][2]=M[0][3]=complex(1.0,0.0);
    M[1][0]=z[1]+z[2]+z[3];
	M[1][1]=z[2]+z[3]+z[0];
	M[1][2]=z[3]+z[0]+z[1];
	M[1][3]=z[0]+z[1]+z[2];
    M[2][0]=z[1]*z[2]+z[2]*z[3]+z[3]*z[1];
    M[2][1]=z[2]*z[3]+z[3]*z[0]+z[0]*z[2];
    M[2][2]=z[3]*z[0]+z[0]*z[1]+z[1]*z[3];
    M[2][3]=z[0]*z[1]+z[1]*z[2]+z[2]*z[0];
    M[3][0]=z[1]*z[2]*z[3];
	M[3][1]=z[2]*z[3]*z[0];
	M[3][2]=z[3]*z[0]*z[1];
	M[3][3]=z[0]*z[1]*z[2];


    complex zz[4];
	zz[0]=yD*ya;
	zz[1]=yb-yc+ya*yd;
	zz[2]=yc*ya*yD;
    zz[3]=yc*ya*yd-yc*yc;

    complex *b,zb[4];
    b=zb;

    csimuleq(M,zz,4,b);


    double omg0=1.0-exp(-1.0/(1.0/qgzai+(qgzai/xd)*(qgzai/xd)/3.0));
    omg0/=1+ya*(yD+yd)+yb/(1+yc);

    complex omg=yD-b[0]*fctherccrF(z[0],yD)
            -b[1]*fctherccrF(z[1],yD)-b[2]*fctherccrF(z[2],yD)-b[3]*fctherccrF(z[3],yD);

    omg/=1+yc;

    return 1.01*kB*zt/(6.0*M_PI*xvisc*xxgzai)*2.0/M_PI*zd*xcp*(real(omg)-omg0);

}
//---------------------------------------------------------------------------
complex fctherccrF(complex xr,double xs)
{
	complex rsq=csqrt(1.0-xr*xr);
	return log((1.0+xr+rsq*tan(0.5*xs))/(1.0+xr-rsq*tan(0.5*xs)))/rsq;
}
//---------------------------------------------------------------------------
double fcvisc0(double xd,double xt)
{
	double xtr=(xt*251.196)/Ts,xdr=xd*ds*Mw*1e-3;

	double lntr=-log(xtr),xdr2=xdr*xdr;
	double xv=0.235156+lntr*(-0.491266+lntr*
    					(5.211155e-2+lntr*(5.347906e-2-lntr*1.537102e-2))),
    	xvd=xdr*(0.4071119e-2+xdr*(0.7198037e-4
    			+xdr2*xdr2*(0.2411697e-16*xtr*xtr*xtr
                +xdr2*(0.2971072e-22-0.1627888e-22*xtr))));

    return 1e-6*(1.006697*sqrt(T0)*exp(-xv)+xvd);
}
//---------------------------------------------------------------------------
double fcvisc(double xd,double xt,double xvisc0,double xtherc0,
        double xxgzai,double xcp,double xcv)
{
	double zd=xd*ds*Mw*1e-3,zt=Ts/xt;

	double qgzai=xxgzai/2.3e-10;
    if(qgzai==0) return xvisc0;

    double qgzai1=sqrt(1+qgzai*qgzai);
    double yD=atan2(xxgzai,2.3e-10);    //atan(qgzai)
    double yd=(atan2(qgzai,qgzai1)-yD)/qgzai1;
	double ya=zd*kB*zt/(8*M_PI*xvisc0*xvisc0*xxgzai),
    		yb=xtherc0/(xvisc0*(xcp-xcv)),yc=xcv/(xcp-xcv);
    double yh=(yd+yb/ya)/yD,yv=yc*yd/yD;


    complex a[]={complex(yv,0),complex(yc,0),
                            complex(yh,0),complex(1.0,0)},z[3];

    sol3(a,z);

    z[0]=-z[0];
    z[1]=-z[1];
    z[2]=-z[2];

    double rz[3];
    rz[0]=real(z[0]);
    rz[1]=real(z[1]);
    rz[2]=real(z[2]);

    if(rz[0]==rz[1]||rz[1]==rz[2]||rz[2]==rz[0]) return -1;
                                                //index as it cannot calculate

	double **M;
	M=(double**) malloc(sizeof(double*)*3);
	M[0]=(double*) malloc(sizeof(double)*3);
	M[1]=(double*) malloc(sizeof(double)*3);
	M[2]=(double*) malloc(sizeof(double)*3);


    M[0][0]=M[0][1]=M[0][2]=1.0;
    M[1][0]=rz[1]+rz[2];
	M[1][1]=rz[2]+rz[0];
	M[1][2]=rz[0]+rz[1];
    M[2][0]=rz[1]*rz[2];
	M[2][1]=rz[2]*rz[0];
	M[2][2]=rz[0]*rz[1];

    double zz[3];
	zz[0]=1.0+yc*(4+3*yc)+yh*(2*yv+yh*(-2-4*yc+yh*yh));
	zz[1]=(yh*yc-yv)*(yh*yh-3*yc-2)+yc*yc*(1+yc)*(1+yc)/(yh*yc-yv);
	zz[2]=yh*yv*(yh*yh-3*yc-2)+yv*yv+yv*yc*(1+yc)*(1+yc)/(yh*yc-yv);

    double *b,zb[3];
    b=zb;

    simuleq(M,zz,3,b);

    double xh=b[0]*fcvisccrF(rz[0],yD)
				+b[1]*fcvisccrF(rz[1],yD)
                +b[2]*fcvisccrF(rz[2],yD);
                +(yh*(3*yc+1.5-yh*yh)-yv)*yD
                +(yh*yh-2*yc-1.25)*sin(yD)-0.25*yh*sin(2*yD)+sin(3*yD)/12.0
                +pow(yc*(1+yc),1.5)/(yv-yc*yh)*atan2(sqrt(yc)*qgzai,sqrt(1+yc));
                                            //cf. tan(yD)=qgzai

    free(M);

	return xvisc0*exp(0.06*xh);
}
//---------------------------------------------------------------------------
double fcvisccrF(double xr,double xs)
{
    if(xr>=1.0) return 0;
	double rsq=sqrt(1.0-xr*xr);
	return log((1.0+xr+rsq*tan(0.5*xs))/(1.0+xr-rsq*tan(0.5*xs)))/rsq;
}
//---------------------------------------------------------------------------
AnsiString AnsiSc(complex xc)
{
	AnsiString asc="";

    if(fabs(real(xc))>=ALM0) asc+=AnsiString(real(xc));
	if(fabs(imag(xc))>ALM0){
    	if(imag(xc)>0&&asc!="") asc+="+";
    	asc+=AnsiString(imag(xc))+"i";
    }
    if(asc=="") asc="0";

    return asc;
}
//---------------------------------------------------------------------------
void fcsatu(double xt,AnsiString *axp,AnsiString *axdg,AnsiString *axdl)
{
	double xp,xdg=0,xdl=0;

	if(xt<=1.0){
    	*axp=*axdg=*axdl="over Tc";
    	return;
    }
    if(xt<Tc/304.12400){  //just an empirical value
    	*axp=*axdg=*axdl="N/A";
    	return;
    }

	double Np[]={0,
			-7.0602087,		1.9391218,		-1.6463597,		-3.2995634
    	};
	double thx=1.0-1.0/xt;
    xp=thx*(Np[1]+Np[2]*sqrt(thx)+thx*(Np[3]+Np[4]*thx*thx));
    xp=exp(xt*xp)*pc;	//1st-expected satu-p


	double Nv[]={0,
			-1.7074879,		-0.8227467,		-4.6008549,
            -10.111178,		-29.742252
    	},
	thv[]={0,
    		0.34,	0.5,	1.0,	7.0/3.0,	14.0/3.0
    	};
    for(int i=1;i<6;i++) xdg+=Nv[i]*pow(thx,thv[i]);
    xdg=exp(xdg);		//1st-expected satu-rho-gas (scaled by ds)


	double Nl[]={0,
			1.9245108,		-0.62385555,	-0.32731127,	0.39245142
    	},
	thl[]={0,
    		0.34,	0.5,	5.0/3.0,	11.0/6.0
    	};

    for(int i=1;i<5;i++) xdl+=Nl[i]*pow(thx,thl[i]);
    xdl=exp(xdl);			//1st-expected satu-rho-liq (scaled by ds)




   	double drx,ddr,px=xp,px0;

	do{

        px0=px;

	    drx=xdg/1.95,ddr=xdg/4;

		do{
    		px=drx*ds*R*T0*fcZ(drx,xt);
    	    if(px>px0) drx-=ddr;
    	    else drx+=ddr;
    	    ddr/=2;
    	    if(drx<0) break;

    	}while(ddr/drx>=ALM0);
        xdg=drx;

   		drx=xdl*1.9,ddr=xdl/2;

        do{
    		px=drx*ds*R*T0*fcZ(drx,xt);
    	    if(px>px0) drx-=ddr;
    	    else drx+=ddr;
    	    ddr/=2;
    	    if(drx<0) break;
        }while(ddr/drx>=ALM0);
        xdl=drx;

        px=ds*R*T0*xdg*xdl/(xdl-xdg)*(log(xdl/xdg)+fc(0,xdl,0,xt)-fc(0,xdg,0,xt));


	}while(fabs(px-px0)/px>=ALM0);

   	*axp=AnsiString(px);
    *axdg=AnsiString(xdg*ds);
    *axdl=AnsiString(xdl*ds);

}
//---------------------------------------------------------------------------
AnsiString fcmeltp(double xt)
{
	double tr=Ts/(xt*216.592);
	double thx=tr-1.0;
    double xp;

    if(tr>=1) xp=1+thx*(1955.539+2055.4593*thx);
	else{
    	double thx09=pow(-thx,0.9);
		xp=exp(-thx/tr*(-14.740846+thx09*(2.4327015-5.3061778*thx)));
    }
    xp*=0.51795e6;

    if(xp>800e6) return ">800MPa";
    else return xp;
}
//---------------------------------------------------------------------------
AnsiString fcrangeT(double xt)
{
	if(xt<216)
		return "Not applied to the range less than 216 K.";
	if(xt>1100)
		return "Not applied to the range more than 1100 K.";
    return "";
}
//---------------------------------------------------------------------------
AnsiString fcrangePT(double xp,double xt)
{
	if(Mp!=0&&xp>Mp)
		return "Suppose to freeze.";
	if(xp<0)
		return "This density is not inadequate.";
	if(xp>800e6)
		return "Not applied to the range more than 800 MPa.";

	return "";
}
//---------------------------------------------------------------------------
double fcZ(double xd,double xt,double xp)
{
	return 1+xd*fc(1,xd,0,Tr);
}
//---------------------------------------------------------------------------
void fcX(double xd,double xt,double xp,
		double *xxF,double *xxU,double *xxH,double *xxG,double *xxS,
        double *xxCv,double *xxCp,double *xxZ,double *xxFP,
        double *xxW,double *xxJT,double *xxC2,double *xxAp,double *xxkT)
{
	//note; fcid does not include log(xd).


        double helm=fc(0,xd,0,xt)+fcid(0,xt)+log(xd),
        		helmT1=xt*(fc(0,xd,1,xt)+fcid(1,xt)),
                helmT2=xt*xt*(fc(0,xd,2,xt)+fcid(2,xt)),
                helmd1=xd*fc(1,xd,0,xt),		// = Z-1
                helmd1T1=xd*xt*fc(1,xd,1,xt),
                helmd2=xd*xd*fc(2,xd,0,xt);

        *xxZ=1+helmd1;
        double RT0=R*T0;

        *xxF=RT0*helm;
        *xxU=RT0*helmT1;
		*xxH=RT0*(*xxZ+helmT1);
		*xxG=RT0*(*xxZ+helm);
        *xxS=R*(helmT1-helm);
        *xxCv=-R*helmT2;

        double ZdT=*xxZ-helmd1T1,ZdT2=2*(*xxZ)-1+helmd2;

        *xxCp=R*(-helmT2+ZdT*ZdT/ZdT2);

		*xxFP=exp(-log(*xxZ)+*xxZ-1+fc(0,xd,0,xt));

		*xxW=sqrt(RT0/Mw*1000*(ZdT2-ZdT*ZdT/helmT2));
        *xxJT=-(*xxZ-1+helmd2+helmd1T1)/(ZdT*ZdT-helmT2*ZdT2)/(R*d0);
        *xxC2=fc(0,0,-2,xt)/ds;
        *xxAp=ZdT/(T0*ZdT2);
        *xxkT=1.0/(d0*RT0*ZdT2);


		double Zc=pc/(dc*R*Tc),gzai,dddp,
                xt445=Tc/445.0,xtref=1.0/1.5; //Tref=1.5Tc
        double ZdT2ref=1+2*xd*fc(1,xd,0,xtref)+xd*xd*fc(2,xd,0,xtref),
                ZdT2445=1+2*xd*fc(1,xd,0,xt445)+xd*xd*fc(2,xd,0,xt445);
            								//Tref=1.5Tc
        if(T0<445.0){
            dddp=Zc*xd*(1.0/ZdT2-xt/(xtref*ZdT2ref));
            if(dddp>=0) gzai=1.50e-10*pow(dddp/0.052,0.630/1.2415);
            else gzai=0;
		}else{
            dddp=Zc*xd*(1.0/ZdT2445-xt/(xtref*ZdT2ref));
            if(dddp>=0)
                gzai=1.50e-10*pow(dddp/0.052,0.630/1.2415)*exp(0.1*(445.0-T0));
            else gzai=0;
        }

	   	double xv,xv0=fcvisc0(xd,xt),xl0=fctherc0(xd,xt);
        if(T0<=1000&&p0<=300e6||T0>1000&&p0<=30e6){
            double xd5=5.0/Mw*1e3/ds;
                        //the viscosity is inflation below  5kg^m-3.
                        //we approximate fcvisc_crit(rho) to rho/5*fcvisc_crit(rho=5)
                        //but this contribution is very little.
            if(xd>=xd5){
                if(gzai!=0){
                    xv=fcvisc(xd,xt,xv0,xl0,gzai,*xxCp/Mw*1e3,*xxCv/Mw*1e3);
                    if(xv>0) Form1->EditVisc->Text=ASDigit(xv);
                    else Form1->EditVisc->Text="N/A ("+ASDigit(xv=xv0)+")";
                }else Form1->EditVisc->Text=ASDigit(xv=xv0);
            }else{
                double xv50=fcvisc0(xd5,xt),
                        xv5=fcvisc(xd5,xt,xv0,xl0,gzai,*xxCp/Mw*1e3,*xxCv/Mw*1e3);
                xv=xv0+(xv5-xv50)*xd/xd5;
                Form1->EditVisc->Text=ASDigit(xv);
            }
        }else Form1->EditVisc->Text="Not treat.";

        double delxl=fctherc(xd,xt,xv0,xv,xl0,gzai,*xxCp/Mw*1e3,*xxCv/Mw*1e3);

        if(delxl==-1) Form1->EditTherc->Text="N/A";
        else{
            double xl=xl0+delxl;
            Form1->EditTherc->Text=ASDigit(xl);
            Form1->EditDth->Text=ASDigit(xl/(*xxCp*xd*ds));
        }

}
//---------------------------------------------------------------------------
