#define MAXN 4
#include "func.h"
#include <stdlib.h>
//---------------------------------------------------------------------------
void __fastcall sol2(complex xa[],complex xz[])
{
	complex cx=csqrt(xa[1]*xa[1]-4*xa[2]*xa[0]);

    xz[0]=(-xa[1]+cx)/(2*xa[2]);
    xz[1]=(-xa[1]-cx)/(2*xa[2]);
}
//---------------------------------------------------------------------------
void __fastcall sol3(complex xa[],complex xz[])
{
	complex p,q,b[3];

	b[0]=xa[0]/xa[3];
	b[1]=xa[1]/xa[3];
	b[2]=xa[2]/xa[3];

    p=(3.0*b[1]-b[2]*b[2])/9.0;
    q=(2.0*b[2]*b[2]*b[2]-9.0*b[2]*b[1]+27.0*b[0])/27.0;

    complex cx,ct1,ct2;
    cx=csqrt(q*q+4.0*p*p*p);


	ct1=ccbrt(0.5*(-q+cx));

    if(norm(ct1)>ALM0*ALM0) ct2=-p/ct1;
    else{
        ct2=ccbrt(0.5*(-q-cx));
        if(norm(ct2)>ALM0*ALM0) ct1=-p/ct2;
        else ct1=ct2=0;
    }
    if(norm(cx+q)<ALM0*norm(cx)){
        ct1=ccbrt(0.5*(-q+cx));
        ct2=-p/ct1;
    }
    if(norm(cx-q)<ALM0*norm(cx)){
        ct2=ccbrt(0.5*(-q-cx));
        ct1=-p/ct2;
    }


   	complex w1=complex(-0.5,0.5*sqrt(3.0)),w2=complex(-0.5,-0.5*sqrt(3.0));

    xz[0]=ct1+ct2-b[2]/3.0;
    xz[1]=ct1*w1+ct2*w2-b[2]/3.0;
    xz[2]=ct1*w2+ct2*w1-b[2]/3.0;

}
//---------------------------------------------------------------------------
void __fastcall sol4(complex xa[],complex xz[])
{
	complex p,q,r,b[4],p3,q3;

	b[0]=xa[0]/xa[4];
	b[1]=xa[1]/xa[4];
	b[2]=xa[2]/xa[4];
	b[3]=xa[3]/xa[4];

    p=-3.0*b[3]*b[3]/8.0+b[2];
    q=0.5*b[3]*(0.25*b[3]*b[3]-b[2])+b[1];
    r=0.25*b[3]*(-b[1]+0.25*b[3]*(b[2]-3.0*b[3]*b[3]/16.0))+b[0];

    complex cb[4],cz[3];
    cb[0]=-q*q/64;
    cb[1]=(p*p-4*r)/16;
    cb[2]=0.5*p;
    cb[3]=1.0;
    sol3(cb,cz);

    complex sqt,ez[4];
    double err[3];
    int si=0;

    for(int ei=0;ei<3;ei++){
        sqt=csqrt(cz[ei]);

        if(sqt!=0){
    	    p3=csqrt(-sqt*sqt-0.5*p-0.25*q/sqt);
    	    q3=csqrt(-sqt*sqt-0.5*p+0.25*q/sqt);

		    ez[0]=sqt+p3-0.25*b[3];
		    ez[1]=sqt-p3-0.25*b[3];
		    ez[2]=-sqt+q3-0.25*b[3];
		    ez[3]=-sqt-q3-0.25*b[3];
        }else ez[0]=ez[1]=ez[2]=ez[3]=-0.25*b[3];

        err[ei]=norm(cpoly4(xa,ez[0]))+norm(cpoly4(xa,ez[1]))
                    +norm(cpoly4(xa,ez[2]))+norm(cpoly4(xa,ez[3]));

        if(err[si]>=err[ei]){
            xz[0]=ez[0];
            xz[1]=ez[1];
            xz[2]=ez[2];
            xz[3]=ez[3];
        }
    }
}
//---------------------------------------------------------------------------
complex __fastcall csqrt(complex xc)
{
    double cr=real(xc),ci=imag(xc);
    if(norm(xc)<ALM0*ALM0) return complex(0,0);

	double rtt=pow(cr*cr+ci*ci,0.25),th=atan2(ci,cr)*0.5;

	return complex(rtt*cos(th),rtt*sin(th));
}
//---------------------------------------------------------------------------
complex __fastcall ccbrt(complex xc)
{
    double cr=real(xc),ci=imag(xc),rtt,th,alm2=ALM0*ALM0;
    if(norm(xc)<alm2) return complex(0,0);

    if(ci*ci<alm2){
        if(cr>=0) return complex(pow(cr,1.0/3.0),0);
        else return complex(-pow(-cr,1.0/3.0),0);
    }
    if(cr*cr<alm2){
        if(ci>=0) return complex(0,-pow(ci,1.0/3.0));
        else return complex(0,pow(-ci,1.0/3.0));
    }

    rtt=pow(cr*cr+ci*ci,1.0/6.0),th=atan2(ci,cr)/3.0;

	return complex(rtt*cos(th),rtt*sin(th));
}
//---------------------------------------------------------------------------
complex __fastcall cpoly4(complex xa[],complex z)
{
    return xa[0]+z*(xa[1]+z*(xa[2]+z*(xa[3]+z*xa[4])));
}
//---------------------------------------------------------------------------
void __fastcall simuleq (double **xa,double *xb,int dim,double *xz)
{


	double **a,*b,*z,**r;
    int i,j,k;

	r=(double**) malloc(sizeof(double*)*dim);
	for(i=0;i<dim;i++) r[i]=(double*) malloc(sizeof(double)*dim);

    a=xa;
    b=xb;
    z=xz;

	for(i=0;i<dim;i++) for(j=0;j<dim;j++) r[i][j]=a[i][j];

	int *m,*n;
	m=(int*) malloc(sizeof(int)*dim);
	n=(int*) malloc(sizeof(int)*dim);

    double c;

	for(k=0;k<dim;k++){
		m[k]=n[k]=k;
        c=r[k][k];
		for(i=k;i<dim;i++){
			for(j=k;j<dim;j++){
				if(r[i][j]*r[i][j]>c*c){    //seek max(rij),i>=k,j>=k
					c=r[i][j];
					m[k]=i;
					n[k]=j;     //m,n=i,j @max(rij) i>=k,j>=k
				}
			}
		}

		if(n[k]>k){
			for(i=0;i<dim;i++){
                swap(r[i][n[k]],r[i][k]);
                r[i][n[k]]*=-1;     //swap column n[k] with *(-1)
			}
		}
		if(m[k]>k){
			for(j=0;j<dim;j++){
                swap(r[m[k]][j],r[k][j]);
                r[m[k]][j]*=-1;     //swap row m[k] with *(-1)
			}
		}
        //Then, c = rkk = max(rij),i>=k,j>=k

		for(j=0;j<dim;j++) if(j!=k) r[k][j]/=-c;
                                    //rkj are normalized by -rkk
        for(i=0;i<dim;i++)
			for(j=0;j<dim;j++) if(i!=k&&j!=k) r[i][j]+=r[i][k]*r[k][j];
                                    //rij=rij-rik*rkj/rkk

		for(i=0;i<dim;i++) if(i!=k) r[i][k]/=c;
        r[k][k]=1.0/c;
	}

	for(k=dim-2;k>=0;k--){
		if(n[k]>k){
			for(j=0;j<dim;j++){
                swap(r[k][j],r[n[k]][j]);
                r[k][j]*=-1;
			}
		}
		if(m[k]>k){
			for(i=0;i<dim;i++){
				swap(r[i][k],r[i][m[k]]);
				r[i][k]*=-1;
			}
		}
	}

    for(i=0;i<dim;i++){
        z[i]=0;
        for(j=0;j<dim;j++) z[i]+=r[i][j]*b[j];
    }


    for(i=0;i<dim;i++) free(r[i]);
    free(r);

}
//---------------------------------------------------------------------------
void __fastcall csimuleq (complex **xa,complex *xb,int dim,complex *xz)
{


	complex **a,*b,*z,**r;
    int i,j,k;

	r=(complex**) malloc(sizeof(complex*)*dim);
	for(i=0;i<dim;i++) r[i]=(complex*) malloc(sizeof(complex)*dim);

    a=xa;
    b=xb;
    z=xz;

	for(i=0;i<dim;i++) for(j=0;j<dim;j++) r[i][j]=a[i][j];

	int *m,*n;
	m=(int*) malloc(sizeof(int)*dim);
	n=(int*) malloc(sizeof(int)*dim);

    complex c;

	for(k=0;k<dim;k++){
		m[k]=n[k]=k;
        c=r[k][k];
		for(i=k;i<dim;i++){
			for(j=k;j<dim;j++){
				if(norm(r[i][j])>norm(c)){    //seek max(rij),i>=k,j>=k
					c=r[i][j];
					m[k]=i;
					n[k]=j;     //m,n=i,j @max(rij) i>=k,j>=k
				}
			}
		}

		if(n[k]>k){
			for(i=0;i<dim;i++){
                swap(r[i][n[k]],r[i][k]);
                r[i][n[k]]*=-1;     //swap column n[k] with *(-1)
			}
		}
		if(m[k]>k){
			for(j=0;j<dim;j++){
                swap(r[m[k]][j],r[k][j]);
                r[m[k]][j]*=-1;     //swap row m[k] with *(-1)
			}
		}
        //Then, c = rkk = max(rij),i>=k,j>=k

		for(j=0;j<dim;j++) if(j!=k) r[k][j]/=-c;
                                    //rkj are normalized by -rkk
        for(i=0;i<dim;i++)
			for(j=0;j<dim;j++) if(i!=k&&j!=k) r[i][j]+=r[i][k]*r[k][j];
                                    //rij=rij-rik*rkj/rkk

		for(i=0;i<dim;i++) if(i!=k) r[i][k]/=c;
        r[k][k]=1.0/c;
	}

	for(k=dim-2;k>=0;k--){
		if(n[k]>k){
			for(j=0;j<dim;j++){
                swap(r[k][j],r[n[k]][j]);
                r[k][j]*=-1;
			}
		}
		if(m[k]>k){
			for(i=0;i<dim;i++){
				swap(r[i][k],r[i][m[k]]);
				r[i][k]*=-1;
			}
		}
	}

    for(i=0;i<dim;i++){
        z[i]=0;
        for(j=0;j<dim;j++) z[i]+=r[i][j]*b[j];
    }


    for(i=0;i<dim;i++) free(r[i]);
    free(r);

}
//---------------------------------------------------------------------------

