#include <math.h>
#include "Unit1.h"
#include "meohfunc.h"
#include "func.h"

//MeOH func
//---------------------------------------------------------------------------
double fm(int dd,double xd,int dt,double xt)
{

	double N[]={0,
        -2.80062505988,			12.5636372418,			-13.0310563173,
        3.26593134060,			-4.11425343805,			3.46397741254,
        -0.0836443967590,		-0.369240098923,		0.00313180842152,
        0.603201474111,			-0.231158593638,		0.106114844945,
        -0.0792228164995,		-0.0000422419150975,    0.00758196739214,
        -0.0000244617434701,	0.00000115080328802,	-12.5099747447,
        27.0392835391,			-21.2070717086,			6.32799472270,
        14.3687921636,			-28.7450766617,			18.5397216068,
        -3.88720372879,			-4.16602487963,			5.29665875982,
        0.509360272812,			-3.30257604839,			-0.311045210826,
        0.273460830583,			0.518916583979,			-0.00227570803104,
        0.0211658196182,		-0.0114335123221,		0.00249860798459,
        -8.19291988442,			0.478601004557,			-0.444161392885,
        0.179621810410,			-0.687602278259,		2.40459848295,
        -6.88463987466,			1.13992982501
		},
    del=1.00863030999,th=0.998480657603;

	int r[]={0,
		1,1,1,1,2,
        2,2,2,2,3,
        3,3,4,4,5,
        6,7,1,1,1,
        1,2,2,2,2,
        3,4,5,5,5,
        5,6,9,6,6,
        4,1,1,1,1,
        1,3,3,3},

	s[]={0,
    	0,1,2,3,1,
        2,3,4,6,0,
        3,4,0,7,1,
        6,7,1,2,3,
        4,1,2,3,5,
        1,2,1,2,4,
        5,2,5,9,14,
        19,2,2,3,3,
        4,3,4,4},		//express si & ji in the original IUPAC

	k[]={0,
	    0,0,0,0,0,
	    0,0,0,0,0,
	    0,0,0,0,0,
	    0,0,2,2,2,
	    2,2,2,2,2,
	    2,2,2,2,2,
	    2,2,2,4,4,
		6,2,3,2,4,
        2,3,2,4};

    int i;
	double xa=0;

    if(dt==0){
	    if(dd==0){
	    	for(i=1;i<18;i++) xa+=N[i]*pow(xd,r[i])*pow(xt,s[i]);
	    	for(i=18;i<37;i++)
    			xa+=N[i]*pow(xd,r[i])*pow(xt,s[i])*exp(-pow(del*xd,k[i]));
    		for(i=37;i<42;i++)
    			xa+=N[i]*pow(xd,r[i])*exp(3.9*th*xt-6.0-pow(s[i]*del*xd,k[i]));
    		for(i=42;i<45;i++)
    			xa+=N[i]*pow(xd,r[i])*exp(23.1*th*xt-25.0-pow(s[i]*del*xd,k[i]));
    	}
	    if(dd==1){
		    for(i=1;i<18;i++) xa+=N[i]*r[i]*pow(xd,r[i]-1)*pow(xt,s[i]);
		    for(i=18;i<37;i++)
		    	xa+=N[i]*pow(xd,r[i]-1)*pow(xt,s[i])
		        		*(r[i]-k[i]*pow(del*xd,k[i]))*exp(-pow(del*xd,k[i]));
    		for(i=37;i<42;i++)
		    	xa+=N[i]*pow(xd,r[i]-1)
		        		*(r[i]-k[i]*pow(s[i]*del*xd,k[i]))
		                *exp(3.9*th*xt-6.0-pow(s[i]*del*xd,k[i]));
		    for(i=42;i<45;i++)
		    	xa+=N[i]*pow(xd,r[i]-1)
		        		*(r[i]-k[i]*pow(s[i]*del*xd,k[i]))
		                *exp(23.1*th*xt-25.0-pow(s[i]*del*xd,k[i]));
        }
	    if(dd==2){
		    for(i=1;i<18;i++) xa+=N[i]*r[i]*(r[i]-1)*pow(xd,r[i]-2)*pow(xt,s[i]);
		    for(i=18;i<37;i++)
		    	xa+=N[i]*pow(xd,r[i]-2)*pow(xt,s[i])
		        		*((r[i]-k[i]*pow(del*xd,k[i]))
                        *(r[i]-1-k[i]*pow(del*xd,k[i]))
		                -k[i]*k[i]*pow(del*xd,k[i]))
		                *exp(-pow(del*xd,k[i]));
    		for(i=37;i<42;i++)
		    	xa+=N[i]*pow(xd,r[i]-2)
		        		*((r[i]-k[i]*pow(s[i]*del*xd,k[i]))
                        *(r[i]-1-k[i]*pow(s[i]*del*xd,k[i]))
		                -k[i]*k[i]*pow(s[i]*del*xd,k[i]))
		                *exp(3.9*th*xt-6.0-pow(s[i]*del*xd,k[i]));
		    for(i=42;i<45;i++)
		    	xa+=N[i]*pow(xd,r[i]-2)
		        		*((r[i]-k[i]*pow(s[i]*del*xd,k[i]))
                        *(r[i]-1-k[i]*pow(s[i]*del*xd,k[i]))
		                -k[i]*k[i]*pow(s[i]*del*xd,k[i]))
		                *exp(23.1*th*xt-25.0-pow(s[i]*del*xd,k[i]));
		}
	}
    if(dt==1){
		if(dd==0){
    		for(i=1;i<18;i++) xa+=N[i]*s[i]*pow(xd,r[i])*pow(xt,s[i]-1);
    		for(i=18;i<37;i++)
    			xa+=N[i]*s[i]*pow(xd,r[i])*pow(xt,s[i]-1)*exp(-pow(del*xd,k[i]));
    		for(i=37;i<42;i++)
		    	xa+=N[i]*3.9*th*pow(xd,r[i])*exp(3.9*th*xt-6.0-pow(s[i]*del*xd,k[i]));
    		for(i=42;i<45;i++)
		    	xa+=N[i]*23.1*th*pow(xd,r[i])*exp(23.1*th*xt-25.0-pow(s[i]*del*xd,k[i]));
		}
		if(dd==1){
		    for(i=1;i<18;i++) xa+=N[i]*r[i]*s[i]*pow(xd,r[i]-1)*pow(xt,s[i]-1);
		    for(i=18;i<37;i++)
		    	xa+=N[i]*s[i]*pow(xd,r[i]-1)*pow(xt,s[i]-1)
		        		*(r[i]-k[i]*pow(del*xd,k[i]))*exp(-pow(del*xd,k[i]));
    		for(i=37;i<42;i++)
		    	xa+=N[i]*3.9*th*pow(xd,r[i]-1)
		        		*(r[i]-k[i]*pow(s[i]*del*xd,k[i]))
		                *exp(3.9*th*xt-6.0-pow(s[i]*del*xd,k[i]));
		    for(i=42;i<45;i++)
		    	xa+=N[i]*23.1*th*pow(xd,r[i]-1)
		        		*(r[i]-k[i]*pow(s[i]*del*xd,k[i]))
		                *exp(23.1*th*xt-25.0-pow(s[i]*del*xd,k[i]));
		}
    }
    if(dt==2){
		if(dd==0){
		    for(i=1;i<18;i++) xa+=N[i]*s[i]*(s[i]-1)*pow(xd,r[i])*pow(xt,s[i]-2);
		    for(i=18;i<37;i++)
		    	xa+=N[i]*s[i]*(s[i]-1)*pow(xd,r[i])
                	*pow(xt,s[i]-2)*exp(-pow(del*xd,k[i]));
   			for(i=37;i<42;i++)
		    	xa+=N[i]*(3.9*th)*(3.9*th)*pow(xd,r[i])
		        	*exp(3.9*th*xt-6.0-pow(s[i]*del*xd,k[i]));
		    for(i=42;i<45;i++)
		    	xa+=N[i]*(23.1*th)*(23.1*th)*pow(xd,r[i])
		        	*exp(23.1*th*xt-25.0-pow(s[i]*del*xd,k[i]));
    	}
    }
    if(dt==-2){	//special form for Second Virial Coef. *ds
		xa=N[1]+xt*(N[2]+N[18]+xt*(N[3]+N[19]+xt*(N[4]+N[20]+xt*N[21])))
        		+(N[37]+N[38]+N[39]+N[40]+N[41])*exp(3.9*th*xt-6.0);
    }

    return xa;
}
//---------------------------------------------------------------------------
double fmid(int dt,double xt)
{
	double F[]={0,
    	2.49667488720,		2.90079118498,		-62.5713535015,
        10.9926773951,		18.3368299465,		-16.3660043791,
        -6.22323476219,		2.80353628228,		1.07780989422,
        0.969656970177
        },
    G[]={0,
    	0,0,0,
        4.11978538315,		3.26499998052,		3.76946349682,
        2.93149354474,		8.22555789084,		10.3162789084,
        0.532489267209
    	};

	double xaid;
	if(dt==0){
	    xaid=F[1]+F[2]*log(xt)+F[3]*xt;
	    for(int i=4;i<11;i++) xaid+=F[i]*log(exp(G[i]*xt)-1);
	}
    if(dt==1){
	    xaid=F[2]/xt+F[3];
	    for(int i=4;i<11;i++) xaid+=F[i]*G[i]*exp(G[i]*xt)/(exp(G[i]*xt)-1);
    }
	if(dt==2){
		xaid=-F[2]/(xt*xt);
    	for(int i=4;i<11;i++)
    		xaid-=F[i]*G[i]*G[i]*exp(G[i]*xt)/((exp(G[i]*xt)-1)*(exp(G[i]*xt)-1));
    }
	return xaid;
}
//---------------------------------------------------------------------------
void fmsatu(double xt,AnsiString *axp,AnsiString *axdg,AnsiString *axdl)
{
	double tr=Ts/xt/Tc,xp=0,xdg=0,xdl=0;

	if(tr>=1.0){
    	*axp=*axdg=*axdl="over Tc";
    	return;
    }

	double Np[]={0,
    	-8.8738823,			2.3698322,			-10.852598,
        -0.12446396
    	};
	double thx=1.0/tr-1.0;
    for(int i=1;i<5;i++) xp+=Np[i]*pow(thx,0.5*(1+i));
    xp=exp(tr*xp)*pc;	//1st-expected satu-p


	if(tr*Tc<=500){

	double Nv[]={0,
    	-9.74320519,		6.27207077e1,		-7.11162934e2,
        -1.28732378e4,		9.54090636e3,		-8.06229292e4,
        8.90380974e4,		-2.68827787e4,		1.53392797e4,
        -1.39186128e4,		-8.77428382e3,		9.25853159e3,
        -7.36156195e3
    	},
	thv[]={0,
    	1.0/6.0,	1.0/3.0,	2.0/3.0,	7.0/6.0,	1.5,
        2.5,		8.0/3.0,	3.5,		5.0,		6.0,
		15.0,		21.0
    	};
	thx=1.0-tr;
    for(int i=1;i<13;i++) xdg+=Nv[i]*pow(thx,thv[i]);
    xdg+=Nv[13]*log(tr);
    xdg=exp(xdg)*8.71e3/ds;	//1st-expected satu-rho-gas (scaled by ds)


	double Nl[]={0,
    	1.8145364,			1.2703194,			-1.0182657,
        2.7562720,			-1.8958692
    	},
	thl[]={0,
		1.0/3.0,	2.0/3.0,	4.0/3.0,	11.0/3.0,	13.0/3.0
    	};

    for(int i=1;i<6;i++) xdl+=Nl[i]*pow(thx,thl[i]);
    xdl*=8.71e3/ds;			//1st-expected satu-rho-liq (scaled by ds)

	}else xdg=xdl=1;


   	double drx,ddr,px=xp,px0;

	do{

        px0=px;

	    drx=xdg/1.95,ddr=xdg/4;

		do{
    		px=drx*ds*R*T0*fmZ(drx,xt);
    	    if(px>px0) drx-=ddr;
    	    else drx+=ddr;
    	    ddr/=2;
    	    if(drx<0) break;
    	}while(ddr/drx>=ALM0);
        xdg=drx;

   		drx=xdl*1.9,ddr=xdl/2;

        do{
    		px=drx*ds*R*T0*fmZ(drx,xt);
    	    if(px>px0) drx-=ddr;
    	    else drx+=ddr;
    	    ddr/=2;
    	    if(drx<0) break;
        }while(ddr/drx>=ALM0);
        xdl=drx;

        px=ds*R*T0*xdg*xdl/(xdl-xdg)*(log(xdl/xdg)+fm(0,xdl,0,xt)-fm(0,xdg,0,xt));


	}while(fabs(px-px0)/px>=ALM0);

   	*axp=AnsiString(px);
    *axdg=AnsiString(xdg*ds);
    *axdl=AnsiString(xdl*ds);

}
//---------------------------------------------------------------------------
AnsiString fmmeltp(double xt)
{
	double tr=Ts/(xt*175.61);
	double thx=tr-1.0;
    double xp=1+thx*(5.320770+4.524780*sqrt(thx)+38.88861*(thx*thx*thx))*1e9;
    xp*=0.187;

    if(xp>250e6) return ">250MPa";
    else return xp;
}
//---------------------------------------------------------------------------
AnsiString fmrangeT(double xt)
{
	if(xt<175.61)
		return "Not applied to the range less than Tt (175.61 K).";
	if(xt>620.0)
		return "Not applied to the range more than 620 K.";
    return "";
}
//---------------------------------------------------------------------------
AnsiString fmrangePT(double xp,double xt)
{
	if(Mp!=0&&xp>Mp)
		return "Suppose to freeze.";
	if(xp<0)
		return "This density is not adequate.";
	if(xp>800e6)
		return "Not applied to the range more than 800 MPa.";
	if(xp>250e6&&xt<300)
		return "Not applied to the range more than 250 MPa in 207 K < T < 300 K.";
	if(xp>0.2e6&&xt>570)
		return "Not applied to the range more than 0.2 MPa in 570 K < T <= 620 K.";

	return "";
}
//---------------------------------------------------------------------------
double fmZ(double xd,double xt,double xp)
{
	return 1+xd*fm(1,xd,0,xt);
}
//---------------------------------------------------------------------------
void fmX(double xd,double xt,double xp,
		double *xxF,double *xxU,double *xxH,double *xxG,double *xxS,
        double *xxCv,double *xxCp,double *xxZ,double *xxFP,
        double *xxW,double *xxJT,double *xxC2,double *xxAp,double *xxkT)
{

        double helm=fm(0,xd,0,xt)+fmid(0,xt)+log(xd/0.0045917679),
        		helmT1=xt*(fm(0,xd,1,xt)+fmid(1,xt)),
                helmT2=xt*xt*(fm(0,xd,2,xt)+fmid(2,xt)),
                helmd1=xd*fm(1,xd,0,xt),		// = Z-1
                helmd1T1=xd*xt*fm(1,xd,1,xt),
                helmd2=xd*xd*fm(2,xd,0,xt);

        *xxZ=1+helmd1;
        double RT0=R*T0;

        *xxF=RT0*helm;
        *xxU=RT0*helmT1;
		*xxH=RT0*(*xxZ+helmT1);
		*xxG=RT0*(*xxZ+helm);
        *xxS=R*(helmT1-helm);
        *xxCv=-R*helmT2;

        double ZdT=*xxZ-helmd1T1,ZdT2=2*(*xxZ)-1+helmd2;

        *xxCp=R*(-helmT2+ZdT*ZdT/ZdT2);

		*xxFP=exp(-log(*xxZ)+*xxZ-1+fm(0,xd,0,xt));

		*xxW=sqrt(RT0/Mw*1000*(ZdT2-ZdT*ZdT/helmT2));
        *xxJT=-(*xxZ-1+helmd2+helmd1T1)/(ZdT*ZdT-helmT2*ZdT2)/(R*d0);
        *xxC2=fm(0,0,-2,xt)/ds;
        *xxAp=ZdT/(T0*ZdT2);
        *xxkT=1.0/(d0*RT0*ZdT2);
}
//---------------------------------------------------------------------------
